﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ConsoleApplication1
{
    public class Case
    {
        private int pens; //מספר העטים בקלמר
        private int pencils; //מספר העפרונות בקלמר
        private string[] colors; //מערך הצבעים בקלמר
        private int numOfColors = 0; //מספר הצבעים בקלמר הנוכחי

        //פעולה בונה
        /*הפעולה מקבלת מספר עטים ומספר עפרונות ובונה קלמר בהתאם
         *  מערך הצבעים מאותחל לגודל 20 ולא מכיל צבעים */
        public Case(int pens, int pencils)
        {
            this.pens = pens;
            this.pencils = pencils;
            this.colors = new string[20];
        }
        //הפעולה מוסיפה עט לקלמר
        public void AddPen()
        {
            this.pens++;
        }
        //הפעולה מוסיפה עפרון לקלמר
        public void AddPencil()
        {
            this.pencils++;
        }

        //הפעולה מוציאה עט מהקלמר במידה ויש עטים בקלמר 
        public void DelPen()
        {
            if (this.pens > 0)
                this.pens--;
        }
        //הפעולה מוציאה עפרון מהקלמר 
        public void DelPencil()
        {
            if (this.pencils > 0)
                this.pencils--;
        }

        //הפעולה מחזירה את מספר העטים בקלמר
        public int GetPens()
        {
            return this.pens;
        }
        //הפעולה מחזירה את מספר העפרונות בקלמר
        public int GetPencils()
        {
            return this.pencils;
        }
        //הפעולה מחזירה את מערך הצבעים בקלמר
        public string[] GetColors()
        {
            return this.colors;
        }
        //הפעולה מחזירה את מספר הצבעים בקלמר
        public int GetNumOfColors()
        {
            return this.numOfColors;
        }

        //הפעולה מוסיפה צבע לקלמר הצבעים
        public void AddColor(string color)
        {
            if (numOfColors < 20)
            {
                this.colors[numOfColors] = color;
                numOfColors++;
            }
        }
        //הפעולה מוציאה צבע מהקלמר
        public void DelColor(string color)
        {
            int i = 0;
            while ((this.colors[i] != color) && (i < numOfColors))
                i++;

            if (i < numOfColors)
            {
                this.numOfColors--;
                for (int j = i; j < numOfColors; j++)
                {
                    this.colors[j] = this.colors[j + 1];
                }
            }

        }
        // הפעולה מקבלת צבע ובודקת אם יש צבע כזה בקלמר
        public bool HasColor(string color)
        {
            for (int i = 0; i < numOfColors; i++)
            {
                if (this.colors[i] == color)
                    return true;
            }
               return false;
        }
       // הפעולה מחזירה מחרוזת המתארת את הקלמר ללא פירוט הצבעים הצבעים
        public override string ToString()
        {
            return "The number of pen is: " + this.pens + "\n"
                + "the number of pencel is: " + this.pencils +"\n"+
                "the number of colors is: "+this.numOfColors;
            
        }
        //הפעולה מחזירה מחרוזת של כל הצבעים בקלמר
        public string ColorsToString()
        {
            string temp = "";
            for (int i = 0; i < numOfColors; i++)
                temp = temp + this.colors[i] + ",";
            return temp;
        }
    } 
     
}
